//
//  MainListViewControllerTests.swift
//  Marveler
//
//  Created by Arash on 12/8/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

@testable import Marveler
import XCTest

class MainListViewControllerTests: XCTestCase {
    // MARK: Subject under test
    
    var sut: MainListViewController!
    var window: UIWindow!
    
    // MARK: Test lifecycle
    
    override func setUp() {
        super.setUp()
        window = UIWindow()
        setupMainListViewController()
    }
    
    override func tearDown() {
        window = nil
        super.tearDown()
    }
    
    // MARK: Test setup
    
    func setupMainListViewController() {
        sut = MainListViewController.loadFromNib()
    }
    
    func loadView() {
        window.addSubview(sut.view)
        RunLoop.current.run(until: Date())
    }
    
    // MARK: Test doubles
    
    class MainListBusinessLogicSpy: MainListBusinessLogic, MainListDataStore {
        var selectedItem: ServerModels.Response.Result?
        var prepareCalled = false
        var didSelectItemCalled = false
        var searchKeyChangedCalled = false
        var listReachedAtCalled = false
        func prepare(request: MainList.Prepare.Request) {
            prepareCalled = true
        }
        
        func didSelectItem(request: MainList.DidSelectItem.Request) {
            didSelectItemCalled = true
        }
        
        func searchKeyChanged(request: MainList.Search.Request) {
            searchKeyChangedCalled = true
        }
        
        func listReachedAt(request: MainList.ListReachedAt.Request) -> Bool {
            listReachedAtCalled = true
            return true
        }
    }
    
    // MARK: testPrepareCalled
    func testPrepareCalled() {
        
        //Given
        let spy = MainListBusinessLogicSpy()
        sut.interactor = spy
        
        //When
        sut.viewDidLoad()
        
        //Then
        XCTAssertTrue(spy.prepareCalled, "should ask the interactor to do an action")
    }
    
    // MARK: testSearchKeyChanged
    func testSearchKeyChanged() {
        
        //Given
        let spy = MainListBusinessLogicSpy()
        sut.interactor = spy
        
        //When
        sut.loadView()
        sut.viewDidLoad()
        sut.searchBar.text = "some dummy text"
        //Then
        XCTAssertTrue(spy.searchKeyChangedCalled, "should ask the interactor to do an action")
    }
    
    // MARK: testDidSelectItemCalled
    func testDidSelectItemCalled() {
        
        //Given
        let spy = MainListBusinessLogicSpy()
        sut.interactor = spy
        let indexPath = IndexPath(row: 0, section: 0)
        //When
        sut.loadView()
        sut.viewDidLoad()
        sut.tableView(sut.tableView, didSelectRowAt: indexPath)
        //Then
        XCTAssertTrue(spy.didSelectItemCalled, "should ask the interactor to do an action")
    }
    
    // MARK: testListReachedAtCalled
    func testListReachedAtCalled() {
        
        //Given
        let spy = MainListBusinessLogicSpy()
        sut.interactor = spy
        let indexPath = IndexPath(row: 0, section: 0)
        
        //When
        sut.loadView()
        sut.viewDidLoad()
        guard let cell = sut.tableView.cellForRow(at: indexPath) else {
            return
        }
        sut.tableView(sut.tableView, willDisplay: cell, forRowAt: indexPath)
        //Then
        XCTAssertTrue(spy.didSelectItemCalled, "should ask the interactor to do an action")
    }
    
    // MARK: testShouldConfigureTableViewCellToDisplayResult
    func testShouldConfigureTableViewCellToDisplayResult() {
        
        //Given
        let spy = MainListBusinessLogicSpy()
        sut.interactor = spy
        let indexPath = IndexPath(row: 0, section: 0)
        let testName = "some dummy name"
        let viewModel = MainList.Prepare.ViewModel.Success(list: [PopulatedResult(id: "test", name: testName, description: "test", imagePath: "test")])
        //When
        sut.loadView()
        sut.viewDidLoad()
        
        sut.displaySuccessPrepare(viewModel: viewModel)
        guard let cell = sut.tableView.cellForRow(at: indexPath) as? ResultCell else {
            return
        }
        //Then
        XCTAssertEqual(cell.name.text, testName, "should be the same")
    }
}
